//  Copyright 2013 Léon Planken and James Boerkoel

/*
    This file is part of the DistSim package.

    DistSim is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DistSim is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DistSim.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * A package for simulating distributed algorithms on a single processor.
 * With suitable modification, it should be possible to run the same code
 * on multiple processors. 
 * 
 * Create a single {@link nl.tudelft.ewi.alg.distsim.MasterProcess} instance
 * and pass it to the constructor of the
 * {@link nl.tudelft.ewi.alg.distsim.DProcess} instances you create.  Then, call
 * {@link nl.tudelft.ewi.alg.distsim.MasterProcess#run()} to set everything in motion.
 * 
 * Optionally, you can specify a network simulator.  This allows detailed simulation
 * of network latency and lossy communication. 
 * 
 * @author L&eacute;on Planken
 * @author James Boerkoel Jr.
 */

package nl.tudelft.ewi.alg.distsim;
